#include <stdio.h>
#include <sys/fcntl.h>

#define  EVEN	1
#define  ODD	2

#define  C_OPTION	1
#define  D_OPTION	10
#define  O_OPTION	8
#define  X_OPTION	16	

extern	int optind;

main(int argc, char *argv[])
{
	void	fatal(char *);
	int	get_string(int, char *);
	void	print_dump(char *, int, int);
	char	buff[BUFSIZ + 1];
	int	fd;
	int	FLAG = ODD;
	int	option = 0;
	int	radix = 0;
	int	buff_size = 0;


	if(argc < 2)
		{
		puts(" : a.out [-cdox] file_name");
		exit(0);
		}

	while((option = getopt(argc, argv, "cdox")) != EOF)
	{
	switch(option)
		{
		case	'c' :
			radix = 1;
			break;	
		case	'd' :
			radix = 10;
			break;	
		case	'o' :
			radix = 8;
			break;	
		case	'x' :
			radix = 16;
			break;	
		}
	} /* while(option) */

	if(**(argv + 1) != '-') radix = 8;

	argv += optind;

	do	{
	if(*argv)
		{
		printf("-> %s <-\n", *argv);
		if((fd = open(*argv, O_RDONLY)) < 0)
			fatal("fopen");

		while((buff_size = get_string(fd, buff)) != 0)
			{
			print_dump(buff, buff_size, radix);
			strcpy(buff, "");
			} /* while(string_size) */

		} /* if(*argv) */

	putchar('\n');

	} while(*argv++);
	
}

int
get_string(int fd, char *buff)
{
	int	read_length = 0;

	read_length = read(fd, buff, BUFSIZ);
	buff[read_length] = '\0';

	return read_length;
	
}

void
print_dump(char *buff, int buff_size, int radix)
{
	void	print_addr(long);
	void	print_number(int, short);
	static	long	count_char;
	char	*ASCII[33];
	int	i;
	int	imsi_count = 0;
	int	FLAG = ODD;
	short	first;
	short	second;
	unsigned	short	pair;


	
	for(i = 0;i < 33;i++)
		ASCII[i] = "    ";

	ASCII[0 ] = "  \\0";
	ASCII[7 ] = "  \\a";
	ASCII[8 ] = "  \\b";
	ASCII[9 ] = "  \\t";
	ASCII[10] = "  \\n";
	ASCII[11] = "  \\v";
	ASCII[12] = "  \\f";
	ASCII[13] = "  \\r";
	ASCII[32] = "    ";

	for(i = 0;i < buff_size;i++, buff++)
	{
	if(count_char % 16 == 0) print_addr(count_char);
	count_char++;
	imsi_count++;
	if(radix == C_OPTION)
		{
		if((*buff < 33) && (*buff >= 0))
			{
			printf("%s", ASCII[*buff]);
			continue;
			}
		if(*buff < 0)	printf("%4d", *buff & 0377);
		else	printf("%4c", *buff);

		}
	else	{
		if(FLAG == ODD)
			{
			first = (short)*buff & 0377;
			first = first << 8;
			if(buff_size < 512 && imsi_count == buff_size)
				{
				second = 0;
				pair = (unsigned short)(first | second);
				print_number(radix, pair);
				print_addr(count_char);
				continue;
				}
			}
		else	second = (short)*buff & 0377;

		if(FLAG == EVEN)
			{
			pair = (unsigned short)(first | second);
			print_number(radix, pair);
			if(buff_size < 512 && imsi_count == buff_size)
				print_addr(count_char);
			} /* if(FLAG) */

		if(FLAG == ODD)
			FLAG = EVEN;
		else	FLAG = ODD;

		
		}
	}
		
}

void
print_addr(long count_char)
{
	int	i;

	putchar('\n');
	for(i = 0;i < 7;i++)
	printf("%c", (char)((count_char >> (18 - 3 * i)) & 07) + '0');
	putchar(' ');
}

void
print_number(int radix, unsigned short pair)
{
	switch(radix)
	{
	case	O_OPTION :
		printf("%06o ", (unsigned short)pair);
		break;
	case	D_OPTION :
		printf("%05d ", (unsigned short)pair);
		break;
	case	X_OPTION :
		printf("%04x ", (unsigned short)pair);
		break;
	}
}
void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
